//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Client.MultiClientTest
{
    
    
    /// <summary>
    /// This is a feature to test different server behaviors when multiple clients request execution of the same command.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("MultiClientTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Multi Client Test")]
    public partial interface IMultiClientTest
    {
        
        /// <summary>
        /// Multiple invocations of this command will be running in parallel
        /// </summary>
        /// <param name="duration">The duration of the command execution</param>
        [Tecan.Sila2.ObservableAttribute()]
        Tecan.Sila2.IObservableCommand RunInParallel([Tecan.Sila2.UnitAttribute("s", Second=1)] double duration);
        
        /// <summary>
        /// Multiple invocations of this command will be queued
        /// </summary>
        /// <param name="duration">The duration of the command execution</param>
        [Tecan.Sila2.ObservableAttribute()]
        Tecan.Sila2.IObservableCommand RunQueued([Tecan.Sila2.UnitAttribute("s", Second=1)] double duration);
        
        /// <summary>
        /// Invocations will be rejected, if there is another command instance already running
        /// </summary>
        /// <param name="duration">The duration of the command execution</param>
        [Tecan.Sila2.ObservableAttribute()]
        Tecan.Sila2.IObservableCommand RejectParallelExecution([Tecan.Sila2.UnitAttribute("s", Second=1)] double duration);
    }
}
